/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_ABSTRACTWALKER_H
#define X3DTK_ABSTRACTWALKER_H

#include "X3DComponentWalker.h"

namespace X3DTK {

/*! \brief Class declared in <b><X3DTK/kernel.h></b> defining a walker for the Abstract
 *  component.
 *
 *  \ingroup processor
 */
 
class AbstractWalker : public X3DComponentWalker
{
public:
  /// Constructor.
  AbstractWalker();
  /// Destructor.
  virtual ~AbstractWalker();
  
  /// Walks an X3DNode.
  virtual void walkX3DAbstractNode(X3DAbstractNode *N) const;
};

}

#endif
