////////////////////////////////////////////////////////////////////////////////
//                            GraphTraversal.inl                              //
////////////////////////////////////////////////////////////////////////////////

namespace X3DTK {

template <class S>
S *GraphTraversal::getInstanceOf()
{
  for (std::list<StateVariables *>::iterator it = _stateVariablesList.begin(); it != _stateVariablesList.end(); ++it)
  {
    if (typeid(*(*it)) == typeid(S))
      return static_cast<S *>(*it);       
  }
  S *s = new S();
  _stateVariablesList.push_back(s);
  return s;
}
  
template <class S>
void GraphTraversal::removeInstanceOf()
{
  for (std::list<StateVariables *>::iterator it = _stateVariablesList.begin(); it != _stateVariablesList.end(); ++it)
  {
    if (typeid(*(*it)) == typeid(S))
    {
      delete *it;
      _stateVariablesList.erase(it);
      break;
    }  
  }
}

}
