namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool readOnly>
MeshInfo<MData, VData, EData, FData, readOnly>::MeshInfo()
: _nFaces(0), _nEdges(0), _nInstances(0)
{
}

template<class MData, class VData, class EData, class FData, bool readOnly>
MeshInfo<MData, VData, EData, FData, readOnly>::~MeshInfo()
{
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void MeshInfo<MData, VData, EData, FData, readOnly>::init()
{
  _nFaces = 0;
  _nEdges = 0;
  _nInstances = 0;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void MeshInfo<MData, VData, EData, FData, readOnly>::addFaces(unsigned int faces)
{
  _nFaces += faces;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void MeshInfo<MData, VData, EData, FData, readOnly>::addEdges(unsigned int edges)
{
  _nEdges += edges;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void MeshInfo<MData, VData, EData, FData, readOnly>::setInstances(unsigned int instances)
{
  _nInstances = instances;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
unsigned int MeshInfo<MData, VData, EData, FData, readOnly>::getFaces() const
{
  return _nFaces;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
unsigned int MeshInfo<MData, VData, EData, FData, readOnly>::getEdges() const
{
  return _nEdges;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
unsigned int MeshInfo<MData, VData, EData, FData, readOnly>::getInstances() const
{
  return _nInstances;
}

template<class VData, class EData, class FData, bool readOnly>
VertexInfo<VData, EData, FData, readOnly>::VertexInfo()
: _nVertices(0), _nInstances(0)
{
}

template<class VData, class EData, class FData, bool readOnly>
VertexInfo<VData, EData, FData, readOnly>::~VertexInfo()
{
}

template<class VData, class EData, class FData, bool readOnly>
void VertexInfo<VData, EData, FData, readOnly>::init()
{
  _nVertices = 0;
  _nInstances = 0;
}

template<class VData, class EData, class FData, bool readOnly>
void VertexInfo<VData, EData, FData, readOnly>::addVertices(unsigned int vertices)
{
  _nVertices += vertices;
}

template<class VData, class EData, class FData, bool readOnly>
void VertexInfo<VData, EData, FData, readOnly>::setInstances(unsigned int instances)
{
  _nInstances = instances;
}

template<class VData, class EData, class FData, bool readOnly>
unsigned int VertexInfo<VData, EData, FData, readOnly>::getVertices() const
{
  return _nVertices;
}

template<class VData, class EData, class FData, bool readOnly>
unsigned int VertexInfo<VData, EData, FData, readOnly>::getInstances() const
{
  return _nInstances;
}


}
}
