namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool readOnly>
NormalsDrawer<MData, VData, EData, FData, readOnly>::NormalsDrawer()
: X3DOnePassProcessor()
{
  stateVariables = GraphTraversal::getInstanceOf<NormalsDrawerStateVariables<MData, VData, EData, FData, readOnly> >();

  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new NormalsDrawerCoreVisitor<MData, VData, EData, FData, readOnly>());
}

template<class MData, class VData, class EData, class FData, bool readOnly>
NormalsDrawer<MData, VData, EData, FData, readOnly>::~NormalsDrawer()
{
  GraphTraversal::removeInstanceOf<NormalsDrawerStateVariables<MData, VData, EData, FData, readOnly> >();
  delete graphTraversal;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsDrawer<MData, VData, EData, FData, readOnly>::draw(X3DNode *N, float amplitude)
{
  if (VData::template find<MESH::VertexPointData>()
   && VData::template find<MESH::VertexNormalData>()
   && FData::template find<MESH::FaceNormalData>())
  { 
    stateVariables->setAmplitude(amplitude);
    stateVariables->init();
    graphTraversal->traverse(N);
    stateVariables->finish();
  }  
}
  
}
}  
