namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool readOnly>
NormalsDrawerStateVariables<MData, VData, EData, FData, readOnly>::NormalsDrawerStateVariables() : StateVariables(), _amplitude(1.0f)
{
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsDrawerStateVariables<MData, VData, EData, FData, readOnly>::init()
{
  _matrixStack.push_front(SFMatrix34f::identity);
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsDrawerStateVariables<MData, VData, EData, FData, readOnly>::finish()
{
  _matrixStack.pop_front();
  if (_matrixStack.size() != 0)
  {
    cx3d << "NormalsDrawerStateVariables::finishTraversal: Non empty matrix stack at the end of NormalsDrawer traversal" << std::endl;
    _matrixStack.clear();
  }
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsDrawerStateVariables<MData, VData, EData, FData, readOnly>::setAmplitude(float amplitude)
{
  _amplitude = amplitude;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
float NormalsDrawerStateVariables<MData, VData, EData, FData, readOnly>::getAmplitude() const {return _amplitude;};

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsDrawerStateVariables<MData, VData, EData, FData, readOnly>::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsDrawerStateVariables<MData, VData, EData, FData, readOnly>::popMatrix()
{
  _matrixStack.pop_front();
}

}
}
