namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool readOnly>
NormalsFlipper<MData, VData, EData, FData, readOnly>::NormalsFlipper()
: X3DOnePassProcessor()
{
  stateVariables = GraphTraversal::getInstanceOf<NormalsFlipperStateVariables<MData, VData, EData, FData, readOnly> >();

  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new NormalsFlipperCoreVisitor<MData, VData, EData, FData, readOnly>());
}

template<class MData, class VData, class EData, class FData, bool readOnly>
NormalsFlipper<MData, VData, EData, FData, readOnly>::~NormalsFlipper()
{
  GraphTraversal::removeInstanceOf<NormalsFlipperStateVariables<MData, VData, EData, FData, readOnly> >();
  delete graphTraversal;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsFlipper<MData, VData, EData, FData, readOnly>::flip(X3DNode *N)
{
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish(); 
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsFlipper<MData, VData, EData, FData, readOnly>::setSelectedNodes(const MFNode &selectedNodes)
{
  stateVariables->setSelectedNodes(selectedNodes);
}

}
}  
