/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_MESH_NORMALSFLIPPERCOREVISITOR_H
#define X3DTK_MESH_NORMALSFLIPPERCOREVISITOR_H

#include "MESH_NormalsFlipperStateVariables.h"
#include "MESH_CoreVisitor.h"
#include "MESH_Mesh.h"
#include "MESH_SceneGraphTypes.h"

#include <map>

namespace X3DTK {
namespace MESH {

/*! \brief Class declared in <b><X3DTK/MESH/normalsflipper.h></b> providing a visitor of the 
 *  Core component of the MESH::NormalsFlipper processor.
 *
 *  \ingroup MESH
 */

template<class MData, class VData, class EData, class FData, bool readOnly>
class NormalsFlipperCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  NormalsFlipperCoreVisitor();

  /// Enters a Mesh.
  virtual void enterVertex(Vertex<VData, EData, FData, readOnly> *V) const;
  /// Walks on a Shape.
  bool walkOnShape(Shape *S, SFAbstractNode child) const;

protected:
  NormalsFlipperStateVariables<MData, VData, EData, FData, readOnly> *stateVariables;
};

}
}

#include "MESH_NormalsFlipperCoreVisitor.inl"

#endif
