namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool readOnly>
NormalsInverter<MData, VData, EData, FData, readOnly>::NormalsInverter()
: X3DOnePassProcessor()
{
  stateVariables = GraphTraversal::getInstanceOf<NormalsInverterStateVariables<MData, VData, EData, FData, readOnly> >();

  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new NormalsInverterCoreVisitor<MData, VData, EData, FData, readOnly>());
}

template<class MData, class VData, class EData, class FData, bool readOnly>
NormalsInverter<MData, VData, EData, FData, readOnly>::~NormalsInverter()
{
  GraphTraversal::removeInstanceOf<NormalsInverterStateVariables<MData, VData, EData, FData, readOnly> >();
  delete graphTraversal;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsInverter<MData, VData, EData, FData, readOnly>::invert(X3DNode *N)
{
//  std::cout << "NormalsInverter<MData, VData, EData, FData, readOnly>::invert" << std::endl;
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish(); 
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsInverter<MData, VData, EData, FData, readOnly>::setSelectedNodes(const MFNode &selectedNodes)
{
  stateVariables->setSelectedNodes(selectedNodes);
}

}
}  
