namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool readOnly>
NormalsInverterStateVariables<MData, VData, EData, FData, readOnly>::NormalsInverterStateVariables()
: StateVariables()
{
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsInverterStateVariables<MData, VData, EData, FData, readOnly>::init()
{
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsInverterStateVariables<MData, VData, EData, FData, readOnly>::finish()
{
  _vertexSetList.clear();
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsInverterStateVariables<MData, VData, EData, FData, readOnly>::addNode(SFAbstractNode N)
{
  _vertexSetList.push_back(N);
}

template<class MData, class VData, class EData, class FData, bool readOnly>
bool NormalsInverterStateVariables<MData, VData, EData, FData, readOnly>::getNode(SFAbstractNode N) const
{
  std::list<SFAbstractNode>::const_iterator it = std::find(_vertexSetList.begin(), _vertexSetList.end(), N);
  return (it != _vertexSetList.end());
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void NormalsInverterStateVariables<MData, VData, EData, FData, readOnly>::setSelectedNodes(const MFNode &selectedNodes)
{
  _selectedNodes = selectedNodes;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
MFNode NormalsInverterStateVariables<MData, VData, EData, FData, readOnly>::getSelectedNodes() const
{
  return _selectedNodes;
}

}
}
