////////////////////////////////////////////////////////////////////////////////
//                            MESH_SFIndirectEdge.inl                         //
////////////////////////////////////////////////////////////////////////////////

namespace X3DTK {
namespace MESH {

template<class EData, class FData, class VData, bool readOnly>
SFIndirectEdge<EData, FData, VData, readOnly>::SFIndirectEdge(SFEdgeContent<EData, FData, VData, readOnly> *const edgeContent)
: SFEdge<EData, FData, VData, readOnly>(edgeContent)
{
}

template<class EData, class FData, class VData, bool readOnly>  
SFIndirectEdge<EData, FData, VData, readOnly>::~SFIndirectEdge() 
{
}

template<class EData, class FData, class VData, bool readOnly>
SFVertex<VData, EData, FData, readOnly> *SFIndirectEdge<EData, FData, VData, readOnly>::getFromVertex() const 
{
  return _edgeContent->getToVertex();
}

template<class EData, class FData, class VData, bool readOnly>
SFVertex<VData, EData, FData, readOnly> *SFIndirectEdge<EData, FData, VData, readOnly>::getToVertex() const 
{
  return _edgeContent->getFromVertex();
}

template<class EData, class FData, class VData, bool readOnly>
const typename SFIndirectEdge<EData, FData, VData, readOnly>::MFFace &SFIndirectEdge<EData, FData, VData, readOnly>::getLeftFaces() const 
{
  return _edgeContent->get2Faces();
}

template<class EData, class FData, class VData, bool readOnly>
const typename SFIndirectEdge<EData, FData, VData, readOnly>::MFFace &SFIndirectEdge<EData, FData, VData, readOnly>::getRightFaces() const 
{
  return _edgeContent->get1Faces();
}

template<class EData, class FData, class VData, bool readOnly>
void SFIndirectEdge<EData, FData, VData, readOnly>::addLeftFace(SFFace<FData, VData, EData, readOnly> *face) 
{
  _edgeContent->add2Face(face);    
}

template<class EData, class FData, class VData, bool readOnly>
void SFIndirectEdge<EData, FData, VData, readOnly>::addRightFace(SFFace<FData, VData, EData, readOnly> *face) 
{
  _edgeContent->add1Face(face);    
}

template<class EData, class FData, class VData, bool readOnly>
void SFIndirectEdge<EData, FData, VData, readOnly>::removeLeftFace(SFFace<FData, VData, EData, readOnly> *face) 
{
  _edgeContent->remove2Face(face);
}

template<class EData, class FData, class VData, bool readOnly>
void SFIndirectEdge<EData, FData, VData, readOnly>::removeRightFace(SFFace<FData, VData, EData, readOnly> *face) 
{
  _edgeContent->remove1Face(face);
}

}
}
