////////////////////////////////////////////////////////////////////////////////
//                            MESH_Vertex.inl                              //
////////////////////////////////////////////////////////////////////////////////

namespace X3DTK {
namespace MESH {

template<class VData, class EData, class FData, bool readOnly>
Vertex<VData, EData, FData, readOnly>::Vertex()
: X3DNode() 
{
  defineTypeName(typeid(*this).name());
}

template<class VData, class EData, class FData, bool readOnly>
SFNode Vertex<VData, EData, FData, readOnly>::clone() const
{
  return new Vertex(*this);  
}

template<class VData, class EData, class FData, bool readOnly>
Vertex<VData, EData, FData, readOnly>::~Vertex() 
{
  // delete vertices
  for (typename MFVertex::iterator it = _vertices.begin(); it != _vertices.end(); ++it)
    delete (*it);
}
  
template<class VData, class EData, class FData, bool readOnly>
SFVertex<VData, EData, FData, readOnly> *Vertex<VData, EData, FData, readOnly>::createVertex() 
{
  SFVertex<VData, EData, FData, readOnly> *V = new SFVertex<VData, EData, FData, readOnly>(_vertices.size());
  _vertices.insert(std::pair<unsigned int, SFVertex<VData, EData, FData, readOnly> *>(_vertices.size(), V));
  return V;
}

template<class VData, class EData, class FData, bool readOnly>
SFVertex<VData, EData, FData, readOnly> *Vertex<VData, EData, FData, readOnly>::createVertex(unsigned int i) 
{
  SFVertex<VData, EData, FData, readOnly> *V = new SFVertex<VData, EData, FData, readOnly>(i);  
  _vertices.insert(std::pair<unsigned int, SFVertex<VData, EData, FData, readOnly> *>(i, V));

  return V;
}  

template<class VData, class EData, class FData, bool readOnly>
const typename Vertex<VData, EData, FData, readOnly>::MFVertex &Vertex<VData, EData, FData, readOnly>::getVertices() const 
{
  return _vertices;
}

template<class VData, class EData, class FData, bool readOnly>
Vertex<VData, EData, FData, readOnly>::Vertex(const Vertex &S)
: X3DNode(S), _vertices(S._vertices)
{
}
  
}
}  
