////////////////////////////////////////////////////////////////////////////////
//                            X3DComponentWalker.inl                          //
////////////////////////////////////////////////////////////////////////////////

namespace X3DTK {

template<class C, class T> 
void X3DComponentWalker::defineWalkingFunction(void (C::*ptrF)(T *) const)
{
  SFType::beginFunctionDefinition();
  WalkingFunction *WF = new WalkingFunction(reinterpret_cast<ptrToWalkingFunction>(ptrF), this);
  //finding if an occurence of T
  T *t = new T();
  SFString name = t->getTypeName();
  SFComponent *TComponent = t->getType()->getComponent();
  //checking if the node belongs to the component.
  if (TComponent != component)
  {
    SFString sg1, sg2;
    if (component->getSceneGraphName() != "")
      sg1 = " of the " + component->getSceneGraphName() + " scene graph";
    if (t->getType()->getSceneGraphName() != "")
      sg1 = " of the " + t->getType()->getSceneGraphName() + " scene graph";  

    cx3d << "warning: defineWalkingFunction for " << name << " which doesn't belong to the " << component->getName() << " component" << sg1 << "," << std::endl;
    cx3d << "         but to the " << t->getType()->getComponentName() << " component" << sg2 << std::endl;    
  }         
  else
    _walkingDict.insert(std::pair<SFString, WalkingFunction *>(t->getType()->getEncodedName(), WF));
  
  delete t;       
  SFType::endFunctionDefinition();
}

}
