////////////////////////////////////////////////////////////////////////////////
//                            X3DProcessor.inl                                //
////////////////////////////////////////////////////////////////////////////////

#include <typeinfo>
#include <iostream>

namespace X3DTK {

template <class P>
P *X3DProcessor::getInstanceOf()
{
  for (std::list<X3DProcessor *>::iterator it = _X3DProcessorList.begin(); it != _X3DProcessorList.end(); ++it)
  {
    if (typeid(*(*it)) == typeid(P))
      return static_cast<P *>(*it);       
  }
  P *p = new P();
  _X3DProcessorList.push_back(p);
  return p;
}

template <class P>
void X3DProcessor::removeInstanceOf()
{
  for (std::list<X3DProcessor *>::iterator it = _X3DProcessorList.begin(); it != _X3DProcessorList.end(); ++it)
  {
    if (typeid(*(*it)) == typeid(P))
    {
      delete *it;
      _X3DProcessorList.erase(it);
      break;
    }  
  }
}

}  
