/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3DTYPESTOSFSTRING_H
#define X3DTK_X3DTYPESTOSFSTRING_H

#include "X3DTypes.h"

namespace X3DTK {

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> returning the SFString DEF="DEF" USE="USE".
SFString toSFString(const SFString &DEF, const SFString &USE);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an MFString to an SFString.
SFString toSFString(const MFString &ms);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an SFBool to an SFString.
SFString toSFString(const SFBool b); 

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an SFInt32 to an SFString.
SFString toSFString(const SFInt32 i); 

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an MFInt32 to an SFString.
SFString toSFString(const MFInt32 &mi);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting a SFFloat to an SFString.
SFString toSFString(const SFFloat f);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an MFFloat to an SFString.
SFString toSFString(const MFFloat &mf);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting a SFDouble to an SFString.
SFString toSFString(const SFDouble d); 

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an MFDouble to an SFString.
SFString toSFString(const MFDouble &md);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting a SFColorRGBA to an SFString.
SFString toSFString(const SFColorRGBA c);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an MFColorRGBA to an SFString.
SFString toSFString(const MFColorRGBA &mc);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an SFColor to an SFString.
SFString toSFString(const SFColor c); 

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an MFColor to an SFString.
SFString toSFString(const MFColor &mc);    

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting a SFVec2f to an SFString.
SFString toSFString(const SFVec2f v);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an MFVec2f to an SFString.
SFString toSFString(const MFVec2f &mv);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting a SFVec3f to an SFString.
SFString toSFString(const SFVec3f v);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an MFVec3f to an SFString.
SFString toSFString(const MFVec3f &mv);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting a SFRotation to an SFString.
SFString toSFString(const SFRotation r);

/// \ingroup types 
/// Function declared in <b><X3DTK/kernel.h></b> converting an MFRotation to an SFString.
SFString toSFString(const MFRotation &mr);

}

#endif
