/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3D_DFSNURBSWalker.h                            //
////////////////////////////////////////////////////////////////////////////////

#ifndef DFSNURBSWALKER_H
#define DFSNURBSWALKER_H

#include "X3DComponentWalker.h"

namespace X3DTK {
namespace X3D {

class NurbsSurface;
class TrimmedSurface;

/// Concrete component walker for the NURBS component and DFS algorithm.

class DFSNURBSWalker : public X3DComponentWalker
{
public:
  /// Constructor.
  DFSNURBSWalker();
  /// Destructor.
  virtual ~DFSNURBSWalker();

  /// Walks a NurbsSurface.
  virtual void walkNurbsSurface(NurbsSurface *N) const;
  /// Walks a TrimmedSurface.
  virtual void walkTrimmedSurface(TrimmedSurface *T) const;
};

}
}

#endif
