/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3D_INLINELOADERCOREVISITOR_H
#define X3DTK_X3D_INLINELOADERCOREVISITOR_H

#include "X3D_CoreVisitor.h"
#include "X3D_InlineLoaderStateVariables.h"

namespace X3DTK {
namespace X3D {

class Scene;
class X3DNode;

/*! \brief Class declared in <b><X3DTK/X3D/inlineloader.h></b> providing a visitor
 *  of the Core component for the X3D::InlineLoader processor.
 *
 *  \ingroup X3D
 */

class InlineLoaderCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  InlineLoaderCoreVisitor();
  /// Destructor.
  virtual ~InlineLoaderCoreVisitor();

/*  /// Enters a Scene.
  virtual void enterScene(Scene *S) const;*/
  /// Enters a X3DNode.
  virtual void enterX3DNode(X3DNode *N) const;
  
/*  /// Walks on a X3DNode.
  virtual bool walkOnX3DNode(X3DNode *N, SFAbstractNode child) const;*/

  /// Leaves an X3DNode.
  virtual void leaveX3DNode(X3DNode *N) const;

protected:
  InlineLoaderStateVariables *stateVariables;
};

}
}

#endif
