/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3D_X3DSceneSaver.h                             //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DSCENESAVER_H
#define X3DSCENESAVER_H

#include "X3D_Scene.h"
#include "X3D_SceneGraphTypes.h"
#include "X3DMultiPassProcessor.h"

namespace X3DTK {
namespace X3D {

/// SceneSaver module.

class X3DSceneSaver : public X3DMultiPassProcessor
{
public:
  /// Constructor.
  X3DSceneSaver();
  /// Destructor.
  virtual ~X3DSceneSaver() = 0;

  /// Writes the content of S in file.
  virtual void saveAs(Scene *S, const SFString &fileName) = 0;
  /// Writes the content of S in file.
  virtual void save(Scene *S) = 0;
};

}
}

#endif
