#include "GL_NormalRendererGroupingVisitor.h"

namespace X3DTK {
namespace GL {

NormalRendererGroupingVisitor::NormalRendererGroupingVisitor()
: GroupingVisitor()
{
  // Enter functions.
  defineEnterFunction(&NormalRendererGroupingVisitor::enterTransform);

  // Leave functions
  defineLeaveFunction(&NormalRendererGroupingVisitor::leaveTransform);
}

void NormalRendererGroupingVisitor::enterTransform(Transform *T) const
{
  // Changing the coordinates system.
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glMultMatrixf(&T->getTransformMatrix().front());
}

void NormalRendererGroupingVisitor::leaveTransform(Transform *) const
{
  // Returning to the old coordinates system.
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();  
}

}
}
