#include "X3D_Icosahedron.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

Icosahedron::Icosahedron()
: X3DGeometry3DNode(), _radius(1.0f)
{
  // Defines the tag of the node. This string must be the same than the one 
  // entered for the creation function, otherwise the node won't be loaded.
  defineTypeName("Icosahedron", "Geometry3D");
}

Icosahedron::Icosahedron(SFFloat radius)
: X3DGeometry3DNode(), _radius(radius)
{
  // Defines the tag of the node.
  defineTypeName("Icosahedron", "Geometry3D");
}

Icosahedron::Icosahedron(const Icosahedron &I)
: X3DGeometry3DNode(I), _radius(I._radius)
{
}

SFNode Icosahedron::clone() const
{
  // Returns the copy constructor.
  return new Icosahedron(*this);
}

void Icosahedron::setRadius(const SFFloat &radius)
{
  _radius = radius;
}
  
void Icosahedron::load(const X3DFileElement *element)
{
  // Converting the text attributes to the memory attributes.
  int index;
  index = element->getIndexAttribute("radius");
  if (index != -1)
    _radius = element->getAttribute(index).toFloat();
}

SFString Icosahedron::write() const
{
  // Converting the memory attributes to the text attributes.
  SFString attr;
  if (_radius != 1.0f)    
    attr += " radius=\"" + toSFString(_radius) + "\"";
      
  return attr;
}

}
}
