#ifndef INFO_H
#define INFO_H

#include <X3DTK/X3D/scenegraph.h>

namespace X3DTK {
namespace X3D {

class Price;
class Modeler;

// Info node.

class Info : public X3DChildNode
{
public:
  Info();
  Info(const SFString &date,
       SFNode price,
       SFNode modeler);
  virtual ~Info();
  virtual SFNode clone() const;  

  void setDate(const SFString &date);
  void setPrice(Price *price);
  void setModeler(Modeler *modeler);  

  inline const SFString &getDate() const {return _date;};
  inline SFNode getPrice() const {return _price;};
  inline SFNode getModeler() const {return _modeler;};  
  
  virtual MFAbstractNode getChildrenList() const;
  
  virtual bool addChild(const SFAbstractNode &N);
  virtual bool setChild(const SFAbstractNode &N);
  virtual bool removeChild(const SFAbstractNode &N);
  
  virtual void load(const X3DFileElement *element);
  virtual SFString write() const;

protected:
  Info(const Info &I);

private:
  SFString _date;
  
  SFNode _price;
  SFNode _modeler;
};

}
}

#endif
