#include "X3D_InfoReader.h"
#include "X3D_MyDFSGraphTraversal.h"
#include "X3D_InfoReaderGroupingVisitor.h"

namespace X3DTK {
namespace X3D {

InfoReader::InfoReader()
{
  // new GraphTraversal.
  graphTraversal = new MyDFSGraphTraversal();
  // Setting the new component visitor.
  graphTraversal->setComponentVisitor(new InfoReaderGroupingVisitor());
}

InfoReader::~InfoReader()
{
  delete graphTraversal;
}

void InfoReader::read(SFNode N)
{
  graphTraversal->traverse(N);
}

}
}
