#include "X3D_InfoReaderGroupingVisitor.h"
#include "X3D_Info.h"
#include "X3D_Price.h"
#include "X3D_Modeler.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

InfoReaderGroupingVisitor::InfoReaderGroupingVisitor()
: GroupingVisitor()
{
  // Enter functions.
  defineEnterFunction(&InfoReaderGroupingVisitor::enterInfo);
  defineEnterFunction(&InfoReaderGroupingVisitor::enterPrice);
  defineEnterFunction(&InfoReaderGroupingVisitor::enterModeler);    
}

void InfoReaderGroupingVisitor::enterInfo(Info *) const
{
  cout << "Informations relative to the scene:"<< endl;
}

void InfoReaderGroupingVisitor::enterPrice(Price *P) const
{
  cout << "  price = " << P->getPrice() << " " << P->getMoney() << endl;
}

void InfoReaderGroupingVisitor::enterModeler(Modeler *M) const
{
  cout << "  realized on the " << M->getName() << " modeler" << endl;
}

}
}
