#include "X3D_MyDFSGroupingWalker.h"
#include "X3D_Info.h"
#include "X3D_Price.h"
#include "X3D_Modeler.h"

#include <iostream>
using namespace std;

namespace X3DTK {
namespace X3D {

MyDFSGroupingWalker::MyDFSGroupingWalker()
: DFSGroupingWalker()
{
  defineWalkingFunction(&MyDFSGroupingWalker::walkInfo);
}

void MyDFSGroupingWalker::walkInfo(Info *I) const
{
  // DFS algorithm scheduling.
  // Entering the node.
  visitor->enter(I);
  
  // Visiting the children.
  SFNode N = I->getPrice();
  if ((N != 0) && (visitor->walkOn(I, N)))
    walker->walk(N);
  
  N = I->getModeler();
  if ((N != 0) && (visitor->walkOn(I, N)))
    walker->walk(N);  
  
  // Leaving the node.
  visitor->leave(I);
}

}
}
