#ifndef PRICE_H
#define PRICE_H

#include <X3DTK/X3D/scenegraph.h>

namespace X3DTK {
namespace X3D {

// Price node.

class Price : public X3DChildNode
{
public:
  Price();
  Price(const SFFloat &price,
        const SFString &money);
            
  virtual SFNode clone() const;  
  void setPrice(const SFFloat &price);
  void setMoney(const SFString &money);

  inline const SFFloat &getPrice() const {return _price;};
  inline const SFString &getMoney() const {return _money;};
 
  virtual void load(const X3DFileElement *element);
  virtual SFString write() const;

protected:
  Price(const Price &I);

private:
  SFFloat _price;
  SFString _money;
};

}
}

#endif
