#include "X3D_InfoReader.h"
#include "X3D_MyGroupingCreator.h"

#include <X3DTK/X3D/scenegraph.h>
#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: infoReader input" << endl;
    exit(0);
  }
  
  // DefaultLoader to load the default X3D Nodes.
  X3D::Loader *loader = X3DLoader::getInstanceOf<X3D::Loader>();
  loader->setComponentCreator(new X3D::MyGroupingCreator());
  
  // Instanciation of the new InfoReader.
  X3D::InfoReader *infoReader = X3DProcessor::getInstanceOf<X3D::InfoReader>();
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1], false);
  // reads the graph.
  infoReader->read(s);
  
  // Removes the instances.
  X3DProcessor::removeInstanceOf<X3D::InfoReader>();
  X3DLoader::removeInstanceOf<X3D::Loader>();
      
  return 1;
}
