#ifndef MESHMYMESHDATA_H
#define MESHMYMESHDATA_H

#include <X3DTK/MESH/scenegraph.h>

namespace X3DTK {
namespace MESH {

// My vertex data structure containing the weight information.

struct VertexWeightData
{
  void setWeight(const SFFloat &weight) {_weight = weight;};
  inline const SFFloat &getWeight() const {return _weight;};
  
private:
  SFFloat _weight;  
};

// My Mesh data aggregates.

typedef clist<tlist<VertexPointData, tlist<VertexNormalData, tlist<VertexWeightData> > > > MyVertexData;
typedef clist<tlist<FaceNormalData> > MyFaceData;
typedef clist<tlist<MeshNormalData> > MyMeshData;

}
}

#endif
