#ifndef MYMESHX3DBUILDERVISITOR_H
#define MYMESHX3DBUILDERVISITOR_H

#include <X3DTK/MESH/x3dbuilder.h>
#include "X3D_MyCoordinate.h"

namespace X3DTK {
namespace MESH {

// Visitor for the Core component of the MyX3DBuilder processor.

template<class MData, class VData, class EData, class FData, bool readOnly>
class MyX3DBuilderCoreVisitor : public X3DBuilderCoreVisitor<MData, VData, EData, FData, readOnly>
{
public:
  MyX3DBuilderCoreVisitor();

  virtual void enterVertex(Vertex<VData, EData, FData, readOnly> *V) const;
  
protected:
  X3DBuilderStateVariables<MData, VData, EData, FData, readOnly> *stateVariables; 
};

}
}

#include "MESH_MyX3DBuilderCoreVisitor.inl"

#endif
