#include "X3D_MyCoordinate.h"

namespace X3DTK {
namespace X3D {

MyCoordinate::MyCoordinate()
: Coordinate()
{
  defineTypeName("MyCoordinate");
}

MyCoordinate::MyCoordinate(const MFVec3f &point, const MFFloat &weight)
: Coordinate(point), _weight(weight)
{
  defineTypeName("MyCoordinate");
}

MyCoordinate::MyCoordinate(const MyCoordinate &C)
: Coordinate(C), _weight(C._weight)
{
}

SFAbstractNode MyCoordinate::clone() const
{
  return new MyCoordinate(*this);
}

MyCoordinate::~MyCoordinate()
{
}
               
void MyCoordinate::setWeight(const MFFloat &weight)            
{
  _weight = weight;
}
  
void MyCoordinate::load(const X3DFileElement *element)
{
  Coordinate::load(element);
  
  int index;
  index = element->getIndexAttribute("weight");
  if (index != -1)
    _weight = MFFloat(element->getAttribute(index));
}

SFString &MyCoordinate::write(SFString &output) const
{
  Coordinate::write(output);
  
  if (!_weight.empty())
    output += " weight=\"" + toSFString(_weight) + "\"";
    
  return output;
}
 
}
}
