namespace X3DTK {
namespace X3D {

template<class MData, class VData, class EData, class FData, bool readOnly>
MyMeshBuilderRenderingVisitor<MData, VData, EData, FData, readOnly>::MyMeshBuilderRenderingVisitor()
: MeshBuilderRenderingVisitor<MData, VData, EData, FData, readOnly>()
{
  defineEnterFunction(&MyMeshBuilderRenderingVisitor::enterMyCoordinate);
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void MyMeshBuilderRenderingVisitor<MData, VData, EData, FData, readOnly>::enterMyCoordinate(MyCoordinate *C) const
{
  MESH::Vertex<VData, EData, FData, readOnly> *MC = dynamic_cast<MESH::Vertex<VData, EData, FData, readOnly> *>(stateVariables->getNode(C));
  if (MC != 0)
  {
    // Filling the Vertices.
    const MFFloat &weight = C->getWeight();
    const typename MESH::Mesh<MData, VData, EData, FData, readOnly>::MFVertex &vertices = MC->getVertices();
    
    // Test the optional presence of MESH::VertexPointData in VData.
    if (VData::template find<MESH::VertexWeightData>() && weight.size() >= vertices.size())
    {
      MFFloat::const_iterator w = weight.begin();
      
      // Accessing the MESH::VertexWeightData of VData.
      for (typename MESH::Mesh<MData, VData, EData, FData, readOnly>::MFVertex::const_iterator v = vertices.begin(); v != vertices.end(); ++v)
      {
        (*v)->template ogetData<MESH::VertexWeightData>().setWeight(*w);
        ++w;  
      }  
    }  
  }
}

}
}
