namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool readOnly>
TransformComputer<MData, VData, EData, FData, readOnly>::TransformComputer()
{
  // Getting the StateVariables
  stateVariables = GraphTraversal::getInstanceOf<TransformComputerStateVariables<MData, VData, EData, FData, readOnly> >();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new TransformComputerCoreVisitor<MData, VData, EData, FData, readOnly>());
}

template<class MData, class VData, class EData, class FData, bool readOnly>
TransformComputer<MData, VData, EData, FData, readOnly>::~TransformComputer()
{
  GraphTraversal::removeInstanceOf<TransformComputerStateVariables<MData, VData, EData, FData, readOnly> >();

  delete graphTraversal;
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void TransformComputer<MData, VData, EData, FData, readOnly>::print(SFNode N)
{
  // Testing the presence of MESH::VertexPointData
  if (VData::template find<MESH::VertexPointData>())
  {
    stateVariables->init();
    graphTraversal->traverse(N);
    stateVariables->finish();
  }  
}

}
}

