#ifndef MESHTRANSFORMCOMPUTERCOREVISITOR_H
#define MESHTRANSFORMCOMPUTERCOREVISITOR_H

#include "MESH_TransformComputerStateVariables.h"

#include <X3DTK/MESH/scenegraph.h>
#include <iostream>

namespace X3DTK {
namespace MESH {

class X3DGroupingNode;
class Transform;

// Visitor for the Core component of the MeshTransformComputer processor.

template<class MData, class VData, class EData, class FData, bool readOnly>
class TransformComputerCoreVisitor : public CoreVisitor
{
public:
  TransformComputerCoreVisitor();

  virtual void enterMesh(Mesh<MData, VData, EData, FData, readOnly> *M) const;
  virtual void enterTransform(Transform *T) const;
  virtual void leaveX3DGroupingNode(X3DGroupingNode *N) const;

protected:
  TransformComputerStateVariables<MData, VData, EData, FData, readOnly> *stateVariables;
};

}
}

#include "MESH_TransformComputerCoreVisitor.inl"

#endif
