namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool readOnly>
TransformComputerStateVariables<MData, VData, EData, FData, readOnly>::TransformComputerStateVariables()
: StateVariables()
{
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void TransformComputerStateVariables<MData, VData, EData, FData, readOnly>::init()
{
  _matrixStack.push_front(SFMatrix34f::identity);
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void TransformComputerStateVariables<MData, VData, EData, FData, readOnly>::finish()
{
  _matrixStack.clear();
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void TransformComputerStateVariables<MData, VData, EData, FData, readOnly>::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void TransformComputerStateVariables<MData, VData, EData, FData, readOnly>::popMatrix()
{
  _matrixStack.pop_front();
}

}
}
