#include "MyMemReleaserAbstractVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {

MyMemReleaserAbstractVisitor::MyMemReleaserAbstractVisitor()
: MemReleaserAbstractVisitor()
{
  // Defines the new enter function for the X3DAbstractNode.
  defineEnterFunction(&MyMemReleaserAbstractVisitor::enterX3DAbstractNode);
  
  // Defines the new enter function for the Cylinder. This method will not be recorded 
  // because X3D::Cylinder doesn't belong to the Abstract component.
  defineEnterFunction(&MyMemReleaserAbstractVisitor::enterCylinder);
}

void MyMemReleaserAbstractVisitor::enterX3DAbstractNode(X3DAbstractNode *N) const
{
  // Prints the name of the node.
  cout << N->getTypeName() << " released" << endl;
  // Call to the super class method.
  MemReleaserAbstractVisitor::enterX3DAbstractNode(N);
}

void MyMemReleaserAbstractVisitor::enterCylinder(X3D::Cylinder *) const
{
  // empty because it will never be called...
}

}
