#include "MyMemReleaser.h"

#include <X3DTK/X3D/scenegraph.h>
#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: mymemreleaser input" << endl;
    exit(0);
  }
  
  // DefaultLoader to load the default X3D Nodes.
  X3D::Loader *loader = X3DLoader::getInstanceOf<X3D::Loader>();
  // Instanciation of MyMemReleaser.
  MemReleaser *releaser = X3DProcessor::getInstanceOf<MyMemReleaser>();
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1]);
  // Releases the memory.
  releaser->release(s);
  
  // removes the instance.
  X3DProcessor::removeInstanceOf<MyMemReleaser>();
  X3DLoader::removeInstanceOf<X3D::Loader>();  
  
  return 1;
}
