#include "MySimpleMesh.h"

#include <iostream>

using namespace std;

MySimpleMesh::MySimpleMesh()
{
}

MySimpleMesh::~MySimpleMesh()
{
}
  
void MySimpleMesh::addVertex(float x, float y, float z)
{
  MyVertex v;
  v.x = x;
  v.y = y;
  v.z = z;
  
  _vertexArray.push_back(v);
}

void MySimpleMesh::addFace(const std::list<unsigned int> &indexes)
{
  _indexArray.push_back(indexes);
}

void MySimpleMesh::print() const
{
  cout << "Vertices: " << endl;
  for (vector<MyVertex>::const_iterator it = _vertexArray.begin(); it != _vertexArray.end(); ++it)
    cout << "  " << (*it).x << ", " << (*it).y << ", " << (*it).z << endl;
  
  cout << "Indexes: " << endl;
  for (vector<MyFace>::const_iterator it = _indexArray.begin(); it != _indexArray.end(); ++it)
  {
    MyFace face = *it;
    cout << "  ";
    for (MyFace::const_iterator itIndex = face.begin(); itIndex != face.end(); ++itIndex)
      cout << *itIndex << " ";
    cout << endl;
  }
}
