#include "MESH_MyStructureComputer.h"

#include <X3DTK/X3D/scenegraph.h>
#include <X3DTK/X3D/meshbuilder.h>
#include <X3DTK/memreleaser.h>

#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: MyStructureComputer input" << endl;
    exit(0);
  }
  
  // DefaultLoader to load the default X3D Nodes.
  X3D::Loader *loader = X3DLoader::getInstanceOf<X3D::Loader>();
  // Instanciation of the new MeshBuilder.
  X3D::DefMeshBuilder *meshbuilder = X3DProcessor::getInstanceOf<X3D::DefMeshBuilder>();
  // Instanciation of the new MyStructureComputer.
  MESH::MyStructureComputer *msc = X3DProcessor::getInstanceOf<MESH::MyStructureComputer>();  
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1], false);
  MESH::Scene *ms = meshbuilder->build(s);
  MySimpleMesh *mesh = msc->compute(ms);  
 
  // prints the content.
  mesh->print();
  
  // removes all the instances.
  X3DProcessor::removeAllInstances();
  X3DLoader::removeInstanceOf<X3D::Loader>();
  
  return 1;
}
