#include "GL_FCylinder.h"
#include "X3D_FCylinder.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

FCylinder::FCylinder()
: Cylinder()
{
  // Defines the tag of the node. 
  defineTypeName("FCylinder");
}

FCylinder::FCylinder(const FCylinder &C)
: Cylinder(C)
{
}

SFNode FCylinder::clone() const
{
  // returns the copy constructor.
  return new FCylinder(*this);
}

void FCylinder::update()
{
  X3D::FCylinder *C = static_cast<X3D::FCylinder *>(x3dReference);
  
  // update the attributes.
  setBottom(C->getBottom());
  setRadius(C->getRadius());
  setHeight(C->getHeight());
  setSide(C->getSide());
  setTop(C->getTop());
  
  // Get the instance of CylinderDrawArray.
  setCylinderArray(CylinderDrawArray::getInstanceOfSection(C->getSection()));
}

}
}
