#include "GL_SimpleAnimator.h"
#include "GL_SimpleAnimatorGeometry3DVisitor.h"

namespace X3DTK {
namespace GL {

SimpleAnimator::SimpleAnimator()
: X3DOnePassProcessor()
{
  // Getting the state variables.
  stateVariables = GraphTraversal::getInstanceOf<SimpleAnimatorStateVariables>();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new SimpleAnimatorGeometry3DVisitor());
}

SimpleAnimator::~SimpleAnimator()
{
  GraphTraversal::removeInstanceOf<SimpleAnimatorStateVariables>();

  delete graphTraversal;
}

void SimpleAnimator::setBBoxSize(const SFVec3f &size)
{
  stateVariables->setBBoxSize(size);
}

void SimpleAnimator::animate(SFNode N, float time)
{
  // Setting the time.
  stateVariables->setTime(time);
  graphTraversal->traverse(N);
}

}
}
